﻿Public Class frmMM
    Dim bytOLD() As Byte
    Dim bolOLD As Boolean
    Public Sub New()
        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        strパス = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location)
    End Sub
    Private Function 選択行(ByVal bolCHK As Boolean) As Integer
        For intROW = 0 To lstTTL.Items.Count - 1
            If lstTTL.Items(intROW).Selected Then Return intROW
        Next
        If bolCHK Then
            Call MessageBox.Show("一覧が選択されていません。", strNAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
        End If
        Return -1
    End Function
    Private Sub txtMLK_DragDrop(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles txtMLK.DragDrop
        Dim strFLE() As String

        strFLE = CType(e.Data.GetData(DataFormats.FileDrop), String())
        If strFLE.Length - 1 < 0 Then Exit Sub
        If System.IO.Path.GetExtension(strFLE(0).ToLower) <> ".mlk" Then Exit Sub

        txtMLK.Text = strFLE(0)
        Call MLK読み込み()
    End Sub
    Private Sub txtMLK_DragEnter(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles txtMLK.DragEnter
        Call File_DragEnter(sender, e)
    End Sub
    Private Sub btnMLK_Click(sender As System.Object, e As System.EventArgs) Handles btnMLK.Click
        Dim strBUF As String = ""
        If Not FILE_DLG(Me, strBUF, "MIDI LINKファイル(*.mlk)|*.mlk", True) Then Exit Sub

        txtMLK.Text = strBUF
        Call MLK読み込み()
    End Sub
    Private Sub txtMLK_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles txtMLK.KeyDown
        If e.KeyCode <> Keys.Enter Then Exit Sub
        Call MLK読み込み()
    End Sub
    Private Sub lstTTL_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstTTL.DragDrop
        Dim strFLE() As String

        strFLE = CType(e.Data.GetData(DataFormats.FileDrop), String())
        If strFLE.Length - 1 < 0 Then Exit Sub

        For Each strCHK In strFLE
            Select Case System.IO.Path.GetExtension(strCHK.ToLower)
                Case ".mid"
                    Call リスト追加(strCHK)
                Case ".mlk"
                    txtMLK.Text = strCHK
                    Call MLK読み込み()
                    Exit Sub
            End Select
        Next

        If chkソート.Checked Then
            Call リストソート(enm項目.ファイル名, SortOrder.Ascending)
        End If
        lstTTL.Items(0).Selected = True
    End Sub
    Private Sub lstTTL_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstTTL.DragEnter
        Call File_DragEnter(sender, e)
    End Sub
    Private Sub lstTTL_SelectedIndexChanged(sender As Object, e As System.EventArgs) Handles lstTTL.SelectedIndexChanged
        Dim intIDX As Integer

        intIDX = 選択行(False)
        If intIDX = -1 Then Exit Sub

        With lstTTL.Items(intIDX)
            Select Case Val(.SubItems(enm項目.状態).Text)
                Case 0
                    rdo通常.Checked = True
                Case 1
                    rdoループ.Checked = True
                Case 2
                    rdo排他.Checked = True
            End Select
        End With

    End Sub
    Private Sub リスト追加(strFLE As String)
        Dim objLST As ListViewItem
        Dim intMAX As Integer
        Dim bytBUF() As Byte

        intMAX = lstTTL.Items.Count
        If intMAX >= 255 Then Exit Sub

        lblサイズ.Text = ""

        objLST = New ListViewItem
        For intCNT = 1 To 8
            objLST.SubItems.Add("")
        Next

        ReDim bytBUF(0)
        Call バイナリ読込(strFLE, bytBUF)
        With objLST
            .SubItems(enm項目.番号).Text = intMAX
            .SubItems(enm項目.ファイル名).Text = System.IO.Path.GetFileName(strFLE)
            .SubItems(enm項目.パス).Text = strFLE
            If chkループチェック.Checked Then
                .SubItems(enm項目.状態).Text = "01"
            Else
                .SubItems(enm項目.状態).Text = "00"
            End If
            .SubItems(enm項目.MIDI位置).Text = "0"
            .SubItems(enm項目.MIDIサイズ).Text = bytBUF.Length
            .SubItems(enm項目.MLK).Text = "False"
        End With

        Call lstTTL.BeginUpdate()
        Call lstTTL.Items.Insert(intMAX, objLST)
        Call lstTTL.EndUpdate()
        Call lstTTL.Items(0).EnsureVisible()

    End Sub
    Private Sub リストソート(ByVal intSEL As Integer, ByVal srtSRT As SortOrder)
        Dim cmpLST As ItemComparer
        Dim strCOL()() As String

        If intSEL = 0 Or lstTTL.Items.Count - 1 = 0 Then Exit Sub

        strCOL = New String(lstTTL.Items.Count - 1)() {}
        cmpLST = New ItemComparer(srtSRT)

        For intROW = 0 To lstTTL.Items.Count - 1
            strCOL(intROW) = New String(lstTTL.Columns.Count - 1) {}
            For intCOL = 1 To lstTTL.Columns.Count - 1
                strCOL(intROW)(intCOL) = lstTTL.Items(intROW).SubItems(intCOL).Text
            Next
            strCOL(intROW)(enm項目.ソート) = strCOL(intROW)(intSEL)
        Next

        Array.Sort(strCOL, cmpLST)

        For intROW = 0 To lstTTL.Items.Count - 1
            lstTTL.Items(intROW).SubItems(enm項目.番号).Text = intROW
            For intCOL = 2 To lstTTL.Columns.Count - 1
                lstTTL.Items(intROW).SubItems(intCOL).Text = strCOL(intROW)(intCOL)
            Next
        Next

    End Sub
    Private Sub btnMID保存_Click(sender As System.Object, e As System.EventArgs) Handles btnMID保存.Click
        Dim strDIR As String = ""
        Dim strNAM As String
        Dim strMLK As String
        Dim bytMID() As Byte
        Dim intSIZ As Integer
        Dim intCNT As Integer

        If Not bolOLD Then
            Call MessageBox.Show("MLKファイルを読み込んでいません。", strNAME, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If Not DIR_DLG(Me, strDIR) Then Exit Sub

        strMLK = IO.Path.GetFileNameWithoutExtension(txtMLK.Text)

        For intIDX = 0 To lstTTL.Items.Count - 1
            With lstTTL.Items(intIDX)
                If CBool(.SubItems(enm項目.MLK).Text) Then
                    intCNT = intCNT + 1

                    If chk超過.Checked And bytOLD(0) = intCNT Then
                        intSIZ = bytOLD.Length - Val(.SubItems(enm項目.MIDI位置).Text)
                        ReDim bytMID(intSIZ - 1)
                        Buffer.BlockCopy(bytOLD, Val(.SubItems(enm項目.MIDI位置).Text), bytMID, 0, intSIZ)
                    Else
                        ReDim bytMID(Val(.SubItems(enm項目.MIDIサイズ).Text) - 1)
                        Buffer.BlockCopy(bytOLD, Val(.SubItems(enm項目.MIDI位置).Text), bytMID, 0, Val(.SubItems(enm項目.MIDIサイズ).Text))
                    End If

                    strNAM = strDIR & "\" & strMLK & Format(intIDX, "000") & ".MID"
                    Call バイナリ書込(strNAM, bytMID)
                End If
            End With
        Next

        Beep()
    End Sub
    Private Sub btnMLK保存_Click(sender As System.Object, e As System.EventArgs) Handles btnMLK保存.Click
        Dim strFLE As String = ""
        Dim bytMLK() As Byte
        Dim bytWRK() As Byte
        Dim bytMID() As Byte
        Dim intSUM As UInteger
        Dim intSTT As Integer
        Dim intHED As Integer
        Dim intBDY As Integer

        ReDim bytMLK(0)
        ReDim bytMID(0)

        If Not FILE_DLG(Me, strFLE, "MIDI LINKファイル(*.mlk)|*.mlk", False) Then Exit Sub

        intHED = 1
        intBDY = 9

        intSTT = intHED + intBDY * lstTTL.Items.Count

        intSUM = intSTT
        For intIDX = 0 To lstTTL.Items.Count - 1
            With lstTTL.Items(intIDX)
                .SubItems(enm項目.MIDI新位置).Text = intSUM
                intSUM = intSUM + Val(.SubItems(enm項目.MIDIサイズ).Text)
            End With
        Next

        ReDim bytMLK(intSUM - 1)

        bytMLK(0) = Val(lstTTL.Items.Count)

        For intIDX = 0 To lstTTL.Items.Count - 1
            With lstTTL.Items(intIDX)
                bytMLK(intHED + intIDX * intBDY + 0) = Val(.SubItems(enm項目.状態).Text)
                bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.MIDI新位置).Text, UInt32))
                bytMLK(intHED + intIDX * intBDY + 1) = bytWRK(0)
                bytMLK(intHED + intIDX * intBDY + 2) = bytWRK(1)
                bytMLK(intHED + intIDX * intBDY + 3) = bytWRK(2)
                bytMLK(intHED + intIDX * intBDY + 4) = bytWRK(3)
                bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.MIDIサイズ).Text, UInt32))
                bytMLK(intHED + intIDX * intBDY + 5) = bytWRK(0)
                bytMLK(intHED + intIDX * intBDY + 6) = bytWRK(1)
                bytMLK(intHED + intIDX * intBDY + 7) = bytWRK(2)
                bytMLK(intHED + intIDX * intBDY + 8) = bytWRK(3)
            End With
        Next

        For intIDX = 0 To lstTTL.Items.Count - 1
            With lstTTL.Items(intIDX)
                If CBool(.SubItems(enm項目.MLK).Text) Then
                    Buffer.BlockCopy(bytOLD, Val(.SubItems(enm項目.MIDI位置).Text), bytMLK, Val(.SubItems(enm項目.MIDI新位置).Text), Val(.SubItems(enm項目.MIDIサイズ).Text))
                Else
                    Call バイナリ読込(.SubItems(enm項目.パス).Text, bytMID)
                    Buffer.BlockCopy(bytMID, 0, bytMLK, Val(.SubItems(enm項目.MIDI新位置).Text), Val(.SubItems(enm項目.MIDIサイズ).Text))
                End If
            End With
        Next

        Call バイナリ書込(strFLE, bytMLK)
        Beep()
    End Sub
    Private Sub btnクリア_Click(sender As System.Object, e As System.EventArgs) Handles btnクリア.Click
        txtMLK.Text = ""
        lblサイズ.Text = ""
        Call リストクリア()
        bolOLD = False
    End Sub
    Private Sub リストクリア()
        Call lstTTL.BeginUpdate()
        Call lstTTL.Items.Clear()
        Call lstTTL.EndUpdate()
    End Sub
    Private Sub MLK読み込み()
        Dim objLST As ListViewItem
        Dim bytCHK() As Byte
        Dim shtCNT As UShort
        Dim intPOS As Integer

        lblサイズ.Text = ""

        Call リストクリア()

        ReDim bytOLD(0)
        ReDim bytCHK(7)
        bolOLD = バイナリ読込(txtMLK.Text, bytOLD)
        If Not bolOLD Then Exit Sub

        Buffer.BlockCopy(bytOLD, 0, bytCHK, 0, 8)

        shtCNT = bytOLD(0)

        For intIDX = 0 To shtCNT - 1
            intPOS = intIDX * 9 + 1

            objLST = New ListViewItem
            For intCNT = 1 To 8
                objLST.SubItems.Add("")
            Next

            With objLST
                .SubItems(enm項目.番号).Text = intIDX
                .SubItems(enm項目.状態).Text = Format(bytOLD(intPOS), "00")
                .SubItems(enm項目.MIDI位置).Text = BitConverter.ToUInt32(bytOLD, intPOS + 1)
                .SubItems(enm項目.MIDIサイズ).Text = BitConverter.ToUInt32(bytOLD, intPOS + 1 + 4)
                .SubItems(enm項目.MLK).Text = "True"
            End With

            If intIDX = shtCNT - 1 Then
                If bytOLD.Length <> Val(objLST.SubItems(enm項目.MIDI位置).Text) + Val(objLST.SubItems(enm項目.MIDIサイズ).Text) Then
                    lblサイズ.Text = "サイズ超過あり"
                End If
            End If

            Call lstTTL.BeginUpdate()
            Call lstTTL.Items.Insert(intIDX, objLST)
            Call lstTTL.EndUpdate()
        Next

        If lstTTL.Items.Count = 0 Then Exit Sub

        Call lstTTL.Items(0).EnsureVisible()
    End Sub
    Private Sub 選択行設定(strWRK As String)
        Dim intIDX As Integer
        intIDX = 選択行(False)
        If intIDX = -1 Then Exit Sub
        lstTTL.Items(intIDX).SubItems(enm項目.状態).Text = strWRK
    End Sub
    Private Sub rdo通常_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rdo通常.CheckedChanged
        Call 選択行設定("00")
    End Sub
    Private Sub rdoループ_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rdoループ.CheckedChanged
        Call 選択行設定("01")
    End Sub
    Private Sub rdo排他_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rdo排他.CheckedChanged
        Call 選択行設定("02")
    End Sub
End Class
